shell教程
OutOfMemory.CN技术专栏-> shell-> shell教程-> 33.7. 各种小技巧

33.7. 各种小技巧

为了记录在一个实际的会话期或多个会话期内运行的用户脚本,可以加下面的代码到每个你想追踪记录的脚本里.这会记录下连续的脚本名记录和调用的次数.#添加(>>)下面几行到你想追踪记录的脚本末尾处.whoami>>$SAVE_FILE#记录调用脚本的用户.echo$0>>$SAVE_FILE#记录脚本名.date>>$SAVE_FILE#记录
  • 为了记录在一个实际的会话期或多个会话期内运行的用户脚本,可以加下面的代码到每个你想追踪记录的脚本里. 这会记录下连续的脚本名记录和调用的次数.

    # 添加(>>)下面几行到你想追踪记录的脚本末尾处.
    
    whoami>> $SAVE_FILE    # 记录调用脚本的用户.
    echo $0>> $SAVE_FILE   # 记录脚本名.
    date>> $SAVE_FILE      # 记录日期和时间.
    echo>> $SAVE_FILE      # 空行作为分隔行.
    
    #  当然, SAVE_FILE 变量应在~/.bashrc中定义并导出(export)
    #+ (变量值类似如 ~/.scripts-run)

  • The >> 操作符可以在文件尾添加内容. 如果你想在文件头添加内容,那应该怎么办?

    file=data.txt
    title="***This is the title line of data text file***"
    
    echo $title | cat - $file >$file.new
    # "cat -" 连接标准输出的内容和$file的内容.
    #  最后的结果就是生成了一个新文件,
    #+ 文件的头添加了 $title 的值,后跟$file的内容.

    这是早先例子 17-13中的简化变体. 当然, , sed 也可以办到.

  • 脚本也可以像内嵌到另一个shell脚本的普通命令一样调用, 如 Tcl wish 脚本, 甚至可以是Makefile. 它们可以作为外部shell命令用C语言的 system() 函数调用, 例如., system("script_name");.

  • 把内嵌的 sedawk 脚本的内容赋值给一个变量可以增加包装脚本(shell wrapper)的可读性. 参考 例子 A-1例子 11-18.

  • 把你最喜欢和最有用的定义和函数放在一些文件中. 当需要的使用的时候, 在脚本中使用dot (.) 或 source 命令来"包含(include)"这些"库文件"的一个或多个.

    # 脚本库
    # ------ -------
    
    # 注:
    # 本文件没有"#!"开头.
    # 也没有真正做执行动作的代码.
    
    
    # 有用的变量定义
    
    ROOT_UID=0             # Root用户的 $UID 值是0.
    E_NOTROOT=101          # 非root用户出错代码.
    MAXRETVAL=255          # 函数最大的的返回值(正值).
    SUCCESS=0
    FAILURE=-1
    
    
    
    # 函数
    
    Usage ()               # "Usage:" 信息(即帮助信息).
    {
      if [ -z "$1" ]       # 没有传递参数.
      then
        msg=filename
      else
        msg=$@
      fi
    
      echo "Usage: `basename $0` "$msg""
    }
    
    
    Check_if_root ()       # 检查是不是root在运行脚本.
    {                      # 取自例子"ex39.sh".
      if [ "$UID" -ne "$ROOT_UID" ]
      then
        echo "Must be root to run this script."
        exit $E_NOTROOT
      fi
    }
    
    
    CreateTempfileName ()  # 创建一个"唯一"的临时文件.
    {                      # 取自例子"ex51.sh".
      prefix=temp
      suffix=`eval date +%s`
      Tempfilename=$prefix.$suffix
    }
    
    
    isalpha2 ()            # 测试字符串是不是都是字母组成的.
    {                      # 取自例子"isalpha.sh".
      [ $# -eq 1 ] || return $FAILURE
    
      case $1 in
      *[!a-zA-Z]*|"") return $FAILURE;;
      *) return $SUCCESS;;
      esac                 # Thanks, S.C.
    }
    
    
    abs ()                           # 绝对值.
    {                                # 注意: 最大的返回值 = 255.
      E_ARGERR=-999999
    
      if [ -z "$1" ]                 # 要传递参数.
      then
        return $E_ARGERR             # 返回错误.
      fi
    
      if [ "$1" -ge 0 ]              # 如果非负的值,
      then                           #
        absval=$1                    # 绝对值是本身.
      else                           # 否则,
        let "absval = (( 0 - $1 ))"  # 改变它的符号.
      fi
    
      return $absval
    }
    
    
    tolower ()             #  把传递的字符串转为小写
    {                      #
    
      if [ -z "$1" ]       #  如果没有传递参数,
      then                 #+ 打印错误信息
        echo "(null)"      #+ (C风格的void指针的错误信息)
        return             #+ 然后从函数中返回.
      fi
    
      echo "$@" | tr A-Z a-z
      # 转换传递过来的所有参数($@).
    
      return
    
    # 用命令替换功能把函数的输出赋给变量.
    # 例如:
    #    oldvar="A seT of miXed-caSe LEtTerS"
    #    newvar=`tolower "$oldvar"`
    #    echo "$newvar"    # 一串混合大小写的字符转换成了全部小写字符
    #
    # 练习: 重写这个函数把传递的参数变为大写
    #       ... toupper()  [容易].
    }

  • 在脚本中添加特殊种类的注释开头标识有助于条理清晰和可读性.

    ## 表示注意.
    rm -rf *.zzy   ##  "rm"命令的"-rf"组合选项非常的危险,
                   ##+ 尤其是对通配符而言.
    
    #+ 表示继续上一行.
    #  这是第一行
    #+ 这是多行的注释,
    #+ 这里是最后一行.
    
    #* 表示标注.
    
    #o 表示列表项.
    
    #> 表示另一个观点.
    while [ "$var1" != "end" ]    #> while test "$var1" != "end"

  • if-test 结构的一种聪明用法是用来注释一块代码块.

    #!/bin/bash
    
    COMMENT_BLOCK=
    #  给上面的变量设置某个值就会产生讨厌的结果
    #
    
    if [ $COMMENT_BLOCK ]; then
    
    Comment block --
    =================================
    This is a comment line.
    This is another comment line.
    This is yet another comment line.
    =================================
    
    echo "This will not echo."
    
    Comment blocks are error-free! Whee!
    
    fi
    
    echo "No more comments, please."
    
    exit 0

    把这种方法和使用here documents来注释代码块作一个比较.

  • 测试$? 退出状态变量, 因为一个脚本可能想要测试一个参数是否只包含数字,以便后面可以把它当作一个整数.

    #!/bin/bash
    
    SUCCESS=0
    E_BADINPUT=65
    
    test "$1" -ne 0 -o "$1" -eq 0 2>/dev/null
    # 整数要么等于零要么不等于零.
    # 2>/dev/null 可以抑制错误信息.
    
    if [ $? -ne "$SUCCESS" ]
    then
      echo "Usage: `basename $0` integer-input"
      exit $E_BADINPUT
    fi
    
    let "sum = $1 + 25"             # 如果$1不是整数就会产生错误.
    echo "Sum = $sum"
    
    # 任何变量,而不仅仅命令行参数可用这种方法来测试.
    
    exit 0

  • 0 - 255 范围的函数返回值是个严格的限制. 用全局变量和其他方法常常出问题. 函数内返回值给脚本主体的另一个办法是让函数写值到标准输出(通常是用echo) 作为"返回值", 并且将其赋给一个变量. 这实际是命令替换(command substitution)的变体.


    例子 33-15. 返回值技巧

    #!/bin/bash
    # multiplication.sh
    
    multiply ()                     # 传递乘数.
    {                               # 能接受多个参数.
    
      local product=1
    
      until [ -z "$1" ]             # 直到所有参数都处理完毕...
      do
        let "product *= $1"
        shift
      done
    
      echo $product                 #  不会打印到标准输出,
    }                               #+ 因为要把它赋给一个变量.
    
    mult1=15383; mult2=25211
    val1=`multiply $mult1 $mult2`
    echo "$mult1 X $mult2 = $val1"
                                    # 387820813
    
    mult1=25; mult2=5; mult3=20
    val2=`multiply $mult1 $mult2 $mult3`
    echo "$mult1 X $mult2 X $mult3 = $val2"
                                    # 2500
    
    mult1=188; mult2=37; mult3=25; mult4=47
    val3=`multiply $mult1 $mult2 $mult3 $mult4`
    echo "$mult1 X $mult2 X $mult3 X $mult4 = $val3"
                                    # 8173300
    
    exit 0

    相同的技术也可用在字符串中. 这意味着函数可以"返回"一个非数字的值.

    capitalize_ichar ()          #  把传递来的参数字符串的第一个字母大写
    {                            #
    
      string0="$@"               # 能接受多个参数.
    
      firstchar=${string0:0:1}   # 第一个字符.
      string1=${string0:1}       # 余下的字符.
    
      FirstChar=`echo "$firstchar" | tr a-z A-Z`
                                 # 第一个字符转换成大写字符.
    
      echo "$FirstChar$string1"  # 打印到标准输出.
    
    }
    
    newstring=`capitalize_ichar "every sentence should start with a capital letter."`
    echo "$newstring"          # Every sentence should start with a capital letter.

    用这种办法甚至可能"返回" 多个值.


    例子 33-16. 返回多个值的技巧

    #!/bin/bash
    # sum-product.sh
    # 函数可以"返回"多个值.
    
    sum_and_product ()   # 计算所传参数的总和与乘积.
    {
      echo $(( $1 + $2 )) $(( $1 * $2 ))
    # 打印每个计算的值到标准输出,各值用空格分隔开.
    }
    
    echo
    echo "Enter first number "
    read first
    
    echo
    echo "Enter second number "
    read second
    echo
    
    retval=`sum_and_product $first $second`      # 把函数的输出赋值给变量.
    sum=`echo "$retval" | awk '{print $1}'`      # 把第一个域的值赋给sum变量.
    product=`echo "$retval" | awk '{print $2}'`  # 把第二个域的值赋给product变量.
    
    echo "$first + $second = $sum"
    echo "$first * $second = $product"
    echo
    
    exit 0

  • 下一个技巧是传递数组函数的技术, 然后 "返回" 一个数组给脚本.

    变量替换(command substitution)把数组的所有元素用空格分隔开来并赋给一个变量就可以实现给函数传递数组. 用先前介绍的方法函数内echo一个数组并"返回此值",然后调用命令替换用 ( ... ) 操作符赋值给一个数组.


    例子 33-17. 传递和返回数组

    #!/bin/bash
    # array-function.sh: 传递一个数组给函数并且...
    #                   从函数"返回"一个数组
    
    
    Pass_Array ()
    {
      local passed_array   # 局部变量.
      passed_array=( `echo "$1"` )
      echo "${passed_array[@]}"
      #  列出新数组中的所有元素
      #+ 新数组是在函数内声明和赋值的.
    }
    
    
    original_array=( element1 element2 element3 element4 element5 )
    
    echo
    echo "original_array = ${original_array[@]}"
    #                      列出最初的数组元素.
    
    
    # 下面是传递数组给函数的技巧.
    # **********************************
    argument=`echo ${original_array[@]}`
    # **********************************
    #  把原数组的所有元素用空格分隔开合成一个字符串并赋给一个变量
    #
    #
    # 注意:只是把数组本身传给函数是不会工作的.
    
    
    # 下面是允许数组作为"返回值"的技巧.
    # *****************************************
    returned_array=( `Pass_Array "$argument"` )
    # *****************************************
    # 把函数的输出赋给数组变量.
    
    echo "returned_array = ${returned_array[@]}"
    
    echo "============================================================="
    
    #  现在,再试一次Now, try it again,
    #+ 尝试在函数外存取(列出)数组.
    Pass_Array "$argument"
    
    # 函数本身可以列出数组,但...
    #+ 函数外存取数组被禁止.
    echo "Passed array (within function) = ${passed_array[@]}"
    # 因为变量是函数内的局部变量,所以只有NULL值.
    
    echo
    
    exit 0

    例子 A-10中有一个更精心制作的给函数传递数组的例子.

  • 利用双括号结构,使在forwhile 循环中可以使用C风格的语法来设置和增加变量. 参考例子 10-12例子 10-17.

  • 在脚本开头设置 pathumask 增加脚本的"可移植性" -- 在某些把 $PATHumask 弄乱的系统里也可以运行.

    #!/bin/bash
    PATH=/bin:/usr/bin:/usr/local/bin ; export PATH
    umask 022   # 脚本的创建的文件有 755 的权限设置.
    
    # 多谢Ian D. Allen提出这个技巧.

  • 一个有用的脚本技术是:重复地把一个过滤器的输出回馈(用管道)给另一个相同过滤器,但过滤器有不同的参数和/或选项. 尤其对 trgrep 更合适.

    # 取自例子"wstrings.sh".
    
    wlist=`strings "$1" | tr A-Z a-z | tr '[:space:]' Z | \
    tr -cs '[:alpha:]' Z | tr -s '\173-\377' Z | tr Z ' '`


    例子 33-18. anagrams游戏

    #!/bin/bash
    # agram.sh: 用anagrams玩游戏.
    
    # 寻找 anagrams ...
    LETTERSET=etaoinshrdlu
    FILTER='.......'       # 最小有多少个字母?
    #       1234567
    
    anagram "$LETTERSET" | # 找出这串字符中所有的 anagrams ...
    grep "$FILTER" |       # 至少7个字符,
    grep '^is' |           # 以'is'开头
    grep -v 's$' |         # 不是复数的(指英文单词复数)
    grep -v 'ed$'          # 不是过去式的(当然也是英文单词)
    # 可以加许多组合条件和过滤器.
    
    #  使用 "anagram" 软件
    #+ 它是作者 "yawl" 单词列表软件包的一部分.
    #  http://ibiblio.org/pub/Linux/libs/yawl-0.3.2.tar.gz
    #  http://personal.riverusers.com/~thegrendel/yawl-0.3.2.tar.gz
    
    exit 0                 # 代码结束.
    
    
    bash$ sh agram.sh
    islander
    isolate
    isolead
    isotheral
    
    
    
    #  练习:
    #  ---------
    #  修改这个脚本使 LETTERSET 能作为命令行参数来接受.
    #  能够传递参数给第 11 - 13 行的过滤器(就像 $FILTER),
    #+ 以便能靠传递参数来指定一种功能.
    
    #  参考agram2.sh了解些微不同的anagram的一种方法
    #

    See also Example 27-3, Example 12-22, and Example A-9.

  • 使用"匿名的 here documents" 来注释代码块,这样避免了对代码块的每一块单独用#来注释了. 参考例子 17-11.

  • 当依赖某个命令脚本在一台没有安装该命令的机器上运行时会出错. 使用 whatis 命令可以避免此问题.

    CMD=command1                 # 第一选择First choice.
    PlanB=command2               # 第二选择Fallback option.
    
    command_test=$(whatis "$CMD" | grep 'nothing appropriate')
    #  如果'command1'没有在系统里发现 , 'whatis'会返回:
    #+ "command1: nothing appropriate."
    #
    #  另一种更安全的办法是:
    #     command_test=$(whereis "$CMD" | grep \/)
    #  但后面的测试判断应该翻转过来,
    #+ 因为$command_test只有当系统存在$CMD命令时才有内容.
    #
    #     (Thanks, bojster.)
    
    
    if [[ -z "$command_test" ]]  # 检查命令是否存在.
    then
      $CMD option1 option2       #  调用command1.
    else                         #  否则,
      $PlanB                     #+ 调用command2.
    fi

  • 在发生错误的情况下 if-grep test 可能不会返回期望的结果,因为文本是打印在标准出错而不是标准输出上.

    if ls -l nonexistent_filename | grep -q 'No such file or directory'
      then echo "File \"nonexistent_filename\" does not exist."
    fi

    把标准出错重定向到标准输出上可以修改这个.

    if ls -l nonexistent_filename 2>&1 | grep -q 'No such file or directory'
    #                             ^^^^
      then echo "File \"nonexistent_filename\" does not exist."
    fi
    
    # 多谢Chris Martin指出.

  • The run-parts 命令很容易依次运行一组命令脚本,特别是和 cronat 组合起来.

  • 在shell脚本里能调用 X-Windows 的窗口小部件将多么美好. 已经存在有几种工具包实现这个了, 它们称为Xscript, Xmenu, 和 widtools. 头两个已经不再维护. 幸运地是仍然可以从这儿下载widtools.

    widtools (widget tools) 工具包要求安装了 XForms 库. 另外, 它的 Makefile 在典型的Linux系统上安装前需要做一些合适的编辑. 最后, 提供的6个部件有3个不能工作 (事实上会发生段错误).

    dialog 工具集提供了shell脚本使用一种称为"对话框"的窗口部件. 原始的 dialog 软件包工作在文本模式的控制台下, 但它的后续软件 gdialog, Xdialog, 和 kdialog 使用基于X-Windows的窗口小部件集.


    例子 33-19. 在shell脚本中调用的窗口部件

    #!/bin/bash
    # dialog.sh: 使用 'gdialog' 窗口部件.
    # 必须在你的系统里安装'gdialog'才能运行此脚本.
    # 版本 1.1 (04/05/05 修正)
    
    # 这个脚本的灵感源自下面的文章.
    #     "Scripting for X Productivity," by Marco Fioretti,
    #      LINUX JOURNAL, Issue 113, September 2003, pp. 86-9.
    # Thank you, all you good people at LJ.
    
    
    # 在窗口中的输入错误.
    E_INPUT=65
    # 输入窗口显示的尺寸.
    HEIGHT=50
    WIDTH=60
    
    # 输出文件名 (由脚本名构建而来).
    OUTFILE=$0.output
    
    # 把这个脚本的内容显示在窗口中.
    gdialog --title "Displaying: $0" --textbox $0 $HEIGHT $WIDTH
    
    
    
    # 现在,保存输入到输出文件中.
    echo -n "VARIABLE=" > $OUTFILE
    gdialog --title "User Input" --inputbox "Enter variable, please:" \
    $HEIGHT $WIDTH 2>> $OUTFILE
    
    
    if [ "$?" -eq 0 ]
    # 检查退出状态是一个好习惯.
    then
      echo "Executed \"dialog box\" without errors."
    else
      echo "Error(s) in \"dialog box\" execution."
            # 或者, 点击"Cancel", 而不是"OK" 按钮.
      rm $OUTFILE
      exit $E_INPUT
    fi
    
    
    
    # 现在,我们重新取得并显示保存的变量.
    . $OUTFILE   # 'Source' 保存的文件(即执行).
    echo "The variable input in the \"input box\" was: "$VARIABLE""
    
    
    rm $OUTFILE  # 清除临时文件.
                 # 有些应用可能需要保留这些文件.
    
    exit $?

    其他的在脚本中使用窗口的工具还有 Tkwish (Tcl 派生物), PerlTk (Perl 的 Tk 扩展), tksh (ksh 的 Tk 扩展), XForms4Perl (Perl 的 XForms 扩展), Gtk-Perl (Perl 的 Gtk 扩展), 或 PyQt (Python 的 Qt 扩展).

  • 为了对复杂的脚本做多次的版本修订管理, 可以使用 rcs 软件包.

    使用这个软件包的好处之一是会自动地升级ID头标识.在 rcsco命令处理一些预定义的关键字参数替换,例如,代替脚本里头#$Id$的,如类似下面的行:

    #$Id: hello-world.sh,v 1.1 2004/10/16 02:43:05 bozo Exp $

© 内存溢出 OutOfMemory.CN